#define Uses_TApplication
#define Uses_TMenuBar
#define Uses_TSubMenu
#define Uses_TMenuItem
#define Uses_TKeys
#define Uses_TScreen
#define Uses_TMouse
#include <tv.h>

#include <graphics.h>

extern Boolean useAltWriteMethod;
// This definition is included to show what it looks like; since
// useAltWriteMethod is True by default in NEWWRITE.OBJ, it is not
// necessary.

class TMyApp : public TApplication
	{
	public:
		TMyApp();

		static TMenuBar *initMenuBar( TRect r );
	};

TMyApp::TMyApp() :
		TProgInit( &TMyApp::initStatusLine, &TMyApp::initMenuBar,
				&TMyApp::initDeskTop )
	{
	}

TMenuBar *TMyApp::initMenuBar( TRect r )
	{
	r.b.y = r.a.y+1;
	return new TMenuBar( r,
		*new TSubMenu( "~F~ile", 0 )+
			*new TMenuItem( "E~x~it", cmQuit, kbAltX, hcNoContext, 0 )
		);
	}

int main()
	{
	int gdriver = EGA;
	int gmode = EGAHI;

	initgraph( &gdriver, &gmode, "\\borlandc\\bgi" );
	if( graphresult() != grOk )
		return 2;
	// This example uses the EGA 640x350x16 graphics mode.

	useAltWriteMethod = True;
	// This is the default, so not actually necessary.

	TScreen::screenHeight = getmaxy() >> 3;
	TMouse::setRange( TScreen::screenWidth-1, TScreen::screenHeight );
	TMouse::show();
	// Need to adjust the screen height and mouse range so that they
	//	both fill the screen. Need to re-show() the mouse because
	//	setting the graphics mode hid it.

	TMyApp app;
	app.run();
	closegraph();
	return 0;
	}
